## Determinant

**Determinantem** čtvercové matice $A = [a_{ij}]$ řádu $n$ nazveme číslo

$$\det(A) = \sum_{\pi}^{} zn(\pi)a_{1\pi(1)}a_{2\pi(2)}\dots a_{n\pi(n)}$$

kde sčítáme přes všechny permutace na množině $\{1, 2, \dots, n\}$.

### Rozvoj podle i-tého řádku

- A je čtvercová matice řádu $n$
- $i \in {\{ 1, 2, ..., n  \}}$
- $det(A) = a_{i1}A_{i1}+a_{i2}A_{i2} + ... + a_{in}A_{in} = \sum_{j=1}^{n}a_{ij}A_{ij}$
- rozvojem se řeší všechny determinanty řádu $n\eq 4$
- elementární úpravy:
	- prohození dvou řádků matice
	- vynásobení (vydělení) řádku matice nenulovým číslem
	- přičtení $k$-násobku $i$-tého řádku k $j$-tému
- pro determinanty můžeme využívat analogicky i sloupcové elementární úpravy ($det(A) = det(A^{T})$)

### Věty

Nechť matice B vznikne z matice A prohozením dvou řádků (sloupců). Potom $\det(B) = -\det(A)$.
- **DK**: Prohozením dvou řádků (sloupců) se změní počet transpozic v každé permutaci o 1, tedy znaménka se změní v opačná.
- z definice determinantu pak plyne, že determinant vyjde opačný k $det(A)$

Má-li matice A **dva stejné řádky** nebo **sloupce**, potom $\det(A) = 0$.
- **DK**: Matice B vznikne z matice A prohozením dvou stejných řádků (sloupců).
- musí platit zároveň, že:
	- $\det(B) = -\det(A)$ z předchozí věty, tedy $0 = -0$
	- matice $B = A$, tedy $\det(B) = \det(A)$, proto $0 = 0$
- Z toho plyne, že determinant je nulový, tedy $\det(A)=\det(B)=0$.

Nechť matice B vznikne z matice A vynásobením $i$-tého řádku (sloupce) číslem $c$. Potom $\det(B) = c \cdot \det(A)$.
- **DK**: Rozvoj v matici B podle $i$-tého řádku:
- $\det(B) = (c \cdot a_{i1} \cdot A_{i1} + c \cdot a_{i2} \cdot A_{i2} + \dots + c \cdot a_{in} \cdot A_{in}) =$ $c \cdot (a_{i1} \cdot A_{i1} + a_{i2} \cdot A_{i2} + \dots + a_{in}*A_{in}) = c \cdot det(A)$

Má-li matice A nějaký řádek nebo sloupec nulový, potom $\det(A) = 0$
- **DK**: Rozvojem podle nulového řádku (či sloupce).

Nechť matice B vznikne z matice A přičtením $c$-násobku $i$-tého řádku (slupce) k $j$-tému řádku (sloupci) ($i \neq j$). Potom $\det(B) = \det(A)$.

Nechť A, B jsou matice řádu $n$. Potom $\det(A \cdot B) = det(A) \cdot det(B)$.